"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.decodeUABoolean = exports.encodeUABoolean = exports.coerceBoolean = exports.decodeBoolean = exports.encodeBoolean = exports.randomBoolean = exports.isValidBoolean = void 0;
/***
 * @module node-opcua-basic-types
 */
const node_opcua_assert_1 = require("node-opcua-assert");
function isValidBoolean(value) {
    return typeof value === "boolean";
}
exports.isValidBoolean = isValidBoolean;
function randomBoolean() {
    return Math.random() > 0.5;
}
exports.randomBoolean = randomBoolean;
function encodeBoolean(value, stream) {
    (0, node_opcua_assert_1.assert)(isValidBoolean(value));
    stream.writeUInt8(value ? 1 : 0);
}
exports.encodeBoolean = encodeBoolean;
function decodeBoolean(stream, _value) {
    return !!stream.readUInt8();
}
exports.decodeBoolean = decodeBoolean;
const falseDetectionRegex = /^(?:f(?:alse)?|no?|0+)$/i;
function coerceBoolean(value) {
    // http://stackoverflow.com/a/24744599/406458
    return !falseDetectionRegex.test(value) && !!value;
    // return !!(+value||String(value).toLowerCase().replace(!!0,''));
}
exports.coerceBoolean = coerceBoolean;
exports.encodeUABoolean = encodeBoolean;
exports.decodeUABoolean = decodeBoolean;
//# sourceMappingURL=boolean.js.map